--*********************************************************
--* FILE  : CHEAP_DAQ.VHD
--* Author: Jack Fried
--*
--* Last Modified: 3/30/2012
--*  
--* CHEAP_DAQ  -- (VMM1 ASIC VERSION)
--*		 		               
--*
--*
--*
--*
--*
--*
--*********************************************************
LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY CHEAP_DAQ_VMM2 IS 
	PORT
	(
		clk_32Mhz 			:  IN  STD_LOGIC;
		clk_50Mhz 			:  IN  STD_LOGIC;
		c_ctl0_flaga 		:  IN  STD_LOGIC;
		c_ctl1_flagb 		:  IN  STD_LOGIC;
		c_ctl2_flagc 		:  IN  STD_LOGIC;		
		c_clkout 			:  IN  STD_LOGIC;
		c_flagd 				:  IN  STD_LOGIC;
		c_int0 				:  IN  STD_LOGIC;
		c_int1 				:  IN  STD_LOGIC;
		c_fd 					:  INOUT  STD_LOGIC_VECTOR(15 DOWNTO 0);
		c_fifoadr0 			:  OUT  STD_LOGIC;
		c_fifoadr1 			:  OUT  STD_LOGIC;
		c_pa2_sloe 			:  OUT  STD_LOGIC;
		c_pktend 			:  OUT  STD_LOGIC;
		c_ifclk 				:  OUT  STD_LOGIC;
		c_slrd 				:  OUT  STD_LOGIC;
		c_slwr 				:  OUT  STD_LOGIC;
		c_wu2 				:  OUT  STD_LOGIC;		
		c_wakeup 			:  OUT  STD_LOGIC;		
		DAC 					:  INOUT  STD_LOGIC_VECTOR(5 DOWNTO 0);
		LEMO 					:  IN  STD_LOGIC_VECTOR(1 DOWNTO 0);
		Testpad4				:  OUT  STD_LOGIC;		
		LX9_DATA    		:  INOUT STD_LOGIC_VECTOR(7 downto 0);	-- cypress slave fifo data	
		LX9_PKTEND     	:  INOUT STD_LOGIC;						-- Packet end (End of data-send via UDP) 		
		LX9_CLK				:  OUT STD_LOGIC;
		LX9_STRB				:  OUT STD_LOGIC;							-- Read/Write Strobe  (dependent on "FIFO Sel") 
		LX9_F_Sel			:  OUT STD_LOGIC_VECTOR(1 downto 0);	-- FIFO Select Address (00  Output FIFO , 01  Input FIFO (REGISTER Write) , 10  Output FIFO (REGISTER Read ) 	
		LX9_F1_3_FF			:  IN  STD_LOGIC;							--	FF, out, FIFO Empty Flag Address(00)
		LX9_F2_EF			:  IN  STD_LOGIC;							--	FE, out, FIFO Full Flag  Address(01) 
		LX9_reset			:  IN  STD_LOGIC;							--	FF, out, FIFO Empty Flag Address(10)	
		
		
		LED 					:  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);		

		
		ADC_1_SCLK			:  OUT  STD_LOGIC;		
		ADC_1_CS				:  OUT  STD_LOGIC;		
		ADC_1_SDATA			:  IN  STD_LOGIC;		
		ADC_2_SCLK			:  OUT  STD_LOGIC;		
		ADC_2_CS				:  OUT  STD_LOGIC;		
		ADC_2_SDATA			:  IN  STD_LOGIC;		
		
		lvds_p_0 			:  INOUT  STD_LOGIC;
		lvds_n_0 			:  INOUT  STD_LOGIC;
		lvds_p_1 			:  INOUT  STD_LOGIC;
		lvds_n_1	 			:  INOUT  STD_LOGIC;
		lvds_p_2 			:  INOUT  STD_LOGIC;
		lvds_n_2 			:  INOUT  STD_LOGIC;
		lvds_p_3 			:  INOUT  STD_LOGIC;
		lvds_n_3 			:  INOUT  STD_LOGIC;
		lvds_p_4 			:  INOUT  STD_LOGIC;
		lvds_n_4 			:  INOUT  STD_LOGIC;
		lvds_p_5 			:  INOUT  STD_LOGIC;
		lvds_n_5 			:  INOUT  STD_LOGIC;
		lvds_p_6 			:  INOUT  STD_LOGIC;
		lvds_n_6 			:  INOUT  STD_LOGIC;
		lvds_p_7 			:  INOUT  STD_LOGIC;
		lvds_n_7 			:  INOUT  STD_LOGIC;
		lvds_p_8 			:  INOUT  STD_LOGIC;
		lvds_n_8 			:  INOUT  STD_LOGIC;
		lvds_p_9 			:  INOUT  STD_LOGIC;
		lvds_n_9 			:  INOUT  STD_LOGIC;
		lvds_p_10 			:  INOUT  STD_LOGIC;
		lvds_n_10 			:  INOUT  STD_LOGIC;
		lvds_p_11 			:  INOUT  STD_LOGIC;
		lvds_n_11 			:  INOUT  STD_LOGIC;
		lvds_p_12 			:  INOUT  STD_LOGIC;
		lvds_n_12 			:  INOUT  STD_LOGIC;
		lvds_p_13 			:  INOUT  STD_LOGIC;
		lvds_n_13			:  INOUT  STD_LOGIC;
		lvds_p_14 			:  INOUT  STD_LOGIC;
		lvds_n_14 			:  INOUT  STD_LOGIC;
		lvds_p_15 			:  INOUT  STD_LOGIC;
		lvds_n_15 			:  INOUT  STD_LOGIC;
		lvds_p_16 			:  INOUT  STD_LOGIC;
		lvds_n_16 			:  INOUT  STD_LOGIC;
		lvds_p_17 			:  INOUT  STD_LOGIC;
		lvds_n_17 			:  INOUT  STD_LOGIC;
		lvds_p_18 			:  INOUT  STD_LOGIC;
		lvds_n_18 			:  INOUT  STD_LOGIC;
		lvds_p_19 			:  INOUT  STD_LOGIC;
		lvds_n_19 			:  INOUT  STD_LOGIC;
		lvds_p_20 			:  INOUT  STD_LOGIC;
		lvds_n_20 			:  INOUT  STD_LOGIC;
		lvds_p_21 			:  INOUT  STD_LOGIC;
		lvds_n_21 			:  INOUT  STD_LOGIC;
		lvds_p_22 			:  INOUT  STD_LOGIC;
		lvds_n_22 			:  INOUT  STD_LOGIC;
		lvds_p_23 			:  INOUT  STD_LOGIC;
		lvds_n_23 			:  INOUT  STD_LOGIC;
		lvds_p_24 			:  INOUT  STD_LOGIC;
		lvds_n_24 			:  INOUT  STD_LOGIC;
		lvds_p_25 			:  INOUT  STD_LOGIC;
		lvds_n_25 			:  INOUT  STD_LOGIC;
		lvds_p_26 			:  INOUT  STD_LOGIC;
		lvds_n_26 			:  INOUT  STD_LOGIC;
		lvds_p_27 			:  INOUT  STD_LOGIC;
		lvds_n_27 			:  INOUT  STD_LOGIC;
		lvds_p_28 			:  INOUT  STD_LOGIC;
		lvds_n_28 			:  INOUT  STD_LOGIC;
		lvds_p_29 			:  INOUT  STD_LOGIC;
		lvds_n_29 			:  INOUT  STD_LOGIC;
		lvds_p_30 			:  INOUT  STD_LOGIC;
		lvds_n_30 			:  INOUT  STD_LOGIC;
		lvds_p_31 			:  INOUT  STD_LOGIC;
		lvds_n_31 			:  INOUT  STD_LOGIC;
		lvds_p_32 			:  INOUT  STD_LOGIC;
		lvds_n_32 			:  INOUT  STD_LOGIC;
		lvds_p_33 			:  INOUT  STD_LOGIC;
		lvds_n_33 			:  INOUT  STD_LOGIC;
		lvds_p_34 			:  INOUT  STD_LOGIC;
		lvds_n_34 			:  INOUT  STD_LOGIC;
		lvds_p_35 			:  INOUT  STD_LOGIC;
		lvds_n_35 			:  INOUT  STD_LOGIC;
		lvds_p_36 			:  INOUT  STD_LOGIC;
		lvds_n_36 			:  INOUT  STD_LOGIC;
		lvds_p_37 			:  INOUT  STD_LOGIC;
		lvds_n_37 			:  INOUT  STD_LOGIC;
		lvds_p_38 			:  INOUT  STD_LOGIC;
		lvds_n_38 			:  INOUT  STD_LOGIC;
		lvds_p_39 			:  INOUT  STD_LOGIC;
		lvds_n_39 			:  INOUT  STD_LOGIC;
		clk_100Mhz			:  out STD_LOGIC;
		sig_tap				:  out STD_LOGIC

	);
END CHEAP_DAQ_VMM2;

ARCHITECTURE bdf_type OF CHEAP_DAQ_VMM2 IS 

COMPONENT alt_iobuf_diff
	PORT(i 		: IN STD_LOGIC;
		 oe 		: IN STD_LOGIC;
		 iobar 	: INOUT STD_LOGIC;
		 io 		: INOUT STD_LOGIC;
		 o 		: OUT STD_LOGIC
	);
END COMPONENT;


component IO_buf_out
	PORT
	(
		datain		: IN STD_LOGIC_VECTOR (0 DOWNTO 0);
		dataout		: OUT STD_LOGIC_VECTOR (0 DOWNTO 0);
		dataout_b		: OUT STD_LOGIC_VECTOR (0 DOWNTO 0)
	);
end component;



COMPONENT USB_TOP
port
	(
	
		USB_IO_CLK 		:  IN  STD_LOGIC;
		reset 			:  IN  STD_LOGIC;	
		c_ctl0_flaga 	:  IN  STD_LOGIC;
		c_ctl1_flagb 	:  IN  STD_LOGIC;
		c_ctl2_flagac 	:  IN  STD_LOGIC;
		c_clkout 		:  IN  STD_LOGIC;	
		c_int0 			:  IN  STD_LOGIC;	
		c_int1 			:  IN  STD_LOGIC;		
		hs_ffdata 		:  IN  STD_LOGIC_VECTOR(15 downto 0);
		hs_ff_wrreq 	:  IN  STD_LOGIC;
		hs_ffclk 		:  IN  STD_LOGIC;	
		data_out 		:  IN  STD_LOGIC_VECTOR(15 downto 0);
		c_ifclk			:  OUT  STD_LOGIC;			
		c_fd 				:  INOUT  STD_LOGIC_VECTOR(15 downto 0);
		c_pa2_sloe 		:  OUT  STD_LOGIC;
		c_rdy0_slrd 	:  OUT  STD_LOGIC;
		c_rdy1_slwr 	:  OUT  STD_LOGIC;		
		c_fifoadr0 		:  OUT  STD_LOGIC;
		c_fifoadr1 		:  OUT  STD_LOGIC;
		c_pktend 		:  OUT  STD_LOGIC;
		c_WU1				:  OUT  STD_LOGIC;
		c_WU2				:  OUT  STD_LOGIC;
		hs_ff_wr_full 	:  OUT  STD_LOGIC;
		address 			:  OUT  STD_LOGIC_VECTOR(15 downto 0);
		data 				:  OUT  STD_LOGIC_VECTOR(15 downto 0);	
		USB_strb 		:  OUT  STD_LOGIC;
		USB_dir 			:  OUT  STD_LOGIC;
		sys_clk			:  in  STD_LOGIC

	);
END COMPONENT;



COMPONENT IO_registers
	PORT(
		rst         : IN STD_LOGIC;				-- state machine reset
		clk         : IN STD_LOGIC;
		USB_data    : IN STD_LOGIC_VECTOR(15 downto 0);	
		USB_address : IN STD_LOGIC_VECTOR(15 downto 0); 
		USB_WR  	 	: IN STD_LOGIC;	
		USB_DIR 	 	: IN STD_LOGIC;
		USB_data_out: OUT  STD_LOGIC_VECTOR(15 downto 0);
		reg0_i		: IN  STD_LOGIC_VECTOR(31 downto 0);		
		reg1_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg2_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg3_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg4_i		: IN  STD_LOGIC_VECTOR(31 downto 0);		
		reg5_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg6_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg7_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg8_i		: IN  STD_LOGIC_VECTOR(31 downto 0);		
		reg9_i		: IN  STD_LOGIC_VECTOR(31 downto 0);
		reg10_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg11_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg12_i		: IN  STD_LOGIC_VECTOR(31 downto 0);		
		reg13_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg14_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg15_i		: IN  STD_LOGIC_VECTOR(31 downto 0);
		reg0_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);		
		reg1_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg2_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg3_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg4_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);		
		reg5_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg6_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg7_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg8_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);		
		reg9_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg10_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg11_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg12_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);		
		reg13_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg14_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg15_o		: OUT  STD_LOGIC_VECTOR(31 downto 0)
	);
END COMPONENT;


COMPONENT al_pll
	PORT(inclk0 : IN STD_LOGIC;
		 c0 		: OUT STD_LOGIC;
		 c1 		: OUT STD_LOGIC
	);
END COMPONENT;

component al_pll_50Mhz
	PORT
	(
		inclk0		: IN STD_LOGIC  := '0';
		c0				: OUT STD_LOGIC;
		c1 			: OUT STD_LOGIC;
		c2				: OUT STD_LOGIC;
		c3				: OUT STD_LOGIC
	);
end component;



component ADC_AD7276_OS
	PORT
	(
		clk      	: IN STD_LOGIC;							-- clock
		rst     		: IN STD_LOGIC;							-- state machine reset
		start   		: IN STD_LOGIC;							-- Start ADC sampling
		ADC_SDO     : IN STD_LOGIC;							-- state machine reset
		OVER_SAMP	: IN STD_LOGIC_VECTOR(1 downto 0);	-- # of samples  00 = 1   01 = 4  10 = 8  11 = 16
		ADC_SCK		: OUT STD_LOGIC;							-- ADC serial clock
		ADC_CS		: OUT STD_LOGIC;							--	ADC CHIP SELECT
		DATA_OUT		: OUT STD_LOGIC_VECTOR(15 downto 0);-- ADC OUTPUT 
		RDY			: OUT STD_LOGIC							-- ADC SAMPLING RDY
	);
end component;
	
	
component VMM2_READOUT 

	PORT
	(
		clk      		: IN STD_LOGIC;						-- clock 50Mhz
		rst     			: IN STD_LOGIC;						-- state machine reset
		ACQ_enable 		: IN STD_LOGIC;						-- state start
		ART_EN			: IN STD_LOGIC;	
		ADC_INT_EN		: IN STD_LOGIC; 			
		TST_PULSE		: IN STD_LOGIC;
		CKBC_PERIOD		: IN STD_LOGIC_VECTOR(15 downto 0);		
		SW_EN				: IN STD_LOGIC; -- enable usb cnt of IO
		SW_vmm2_TKI		: IN STD_LOGIC; 
		SW_vmm2_DI		: IN STD_LOGIC; 
		SW_vmm2_CKTK	: IN STD_LOGIC; 
		SW_vmm2_ENA		: IN STD_LOGIC; 
		SW_vmm2_CKBC	: IN STD_LOGIC; 
		SW_vmm2_CKART	: IN STD_LOGIC; 
		SW_vmm2_CKDT	: IN STD_LOGIC; 
		SW_VMM2_WEN		: IN STD_LOGIC; 
		SW_VMM2_CKTP	: IN STD_LOGIC; 

	
		VMM2_TKI			: OUT STD_LOGIC;	
		VMM2_DI			: OUT STD_LOGIC;			
		VMM2_CKTK		: OUT STD_LOGIC;	
		VMM2_ENA			: OUT STD_LOGIC;	
		VMM2_CKBC		: OUT STD_LOGIC;
		VMM2_CKART		: OUT STD_LOGIC;
		VMM2_CKDT		: OUT STD_LOGIC;	
		VMM2_WEN			: OUT STD_LOGIC;	
		VMM2_CKTP		: OUT STD_LOGIC;	
	
		VMM2_ART			: IN STD_LOGIC;	
		VMM2_SETT		: IN STD_LOGIC;	
		VMM2_DATA1		: IN STD_LOGIC;	
		VMM2_DATA0		: IN STD_LOGIC;	
		VMM2_TKO			: IN STD_LOGIC;
		ADDR_OUT			: OUT STD_LOGIC_VECTOR(7 downto 0);
		USB_DATA			: OUT STD_LOGIC_VECTOR(15 downto 0);
		USB_LATCH		: OUT STD_LOGIC
	
	);
end component;
	
	
component  VMM2_TST_PULSE 
	PORT
	(
		sys_rst     	: IN STD_LOGIC;			
		clk_40Mhz    	: IN STD_LOGIC;				-- clock
		TP_ENABLE		: IN STD_LOGIC;
		TP_PERIOD		: IN STD_LOGIC_VECTOR(31 downto 0);		--  0 = 25ns 1 = 50ns ......
		TP_WIDTH			: IN STD_LOGIC_VECTOR(15 downto 0);		--  0 = 25ns 1 = 50ns ......
		TP_P_TRAIN		: IN STD_LOGIC_VECTOR(7 downto 0);		--  0 = 1 , 1 = 1, 2 = 2 ......
		TST_PULSE		: OUT STD_LOGIC
	);

end component;
	
	
SIGNAL	c50Mhz 		:  STD_LOGIC;
SIGNAL	reset 		:  STD_LOGIC;
SIGNAL	usb_reset 	:  STD_LOGIC;
SIGNAL	USB_CLK 		:  STD_LOGIC;
SIGNAL	USB_dir 		:  STD_LOGIC;
SIGNAL	USB_strb 	:  STD_LOGIC;
SIGNAL	wr_full 		:  STD_LOGIC;
SIGNAL	address 		:  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	data 			:  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	rdout 		:  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	reg0_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg1_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg2_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg3_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg4_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg5_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg6_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg7_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg8_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg9_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg10_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg11_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg12_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg13_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg14_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	reg15_p 		:  STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL   SIG_IN		:	STD_LOGIC;

--SIGNAL	data1_o		:  STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	USB_wfull		: STD_LOGIC;		
SIGNAL	USB_HS_CLK		: STD_LOGIC;		
SIGNAL	USB_DATA			: STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	USB_wrreq		: STD_LOGIC;		
SIGNAL   clk_1Mhz			: STD_LOGIC;
SIGNAL   CHIP_RST			: STD_LOGIC;

SIGNAL	ADC_SCK			: STD_LOGIC;
SIGNAL	ADC_CS			: STD_LOGIC;
SIGNAL	ADC_DATA1		: STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL	ADC_DATA2		: STD_LOGIC_VECTOR(31 DOWNTO 0);

SIGNAL	vmm_io_out	: STD_LOGIC_VECTOR(31 DOWNTO 0);

----------VMM2  IO SINGNALS -------------------
											--		 I/O FROM 
											--		 ASIC side
SIGNAL	VMM2_SETB		: STD_LOGIC;	--	output  lvds 18
SIGNAL	VMM2_TKI			: STD_LOGIC;	--	input   lvds 20
SIGNAL	VMM2_ART			: STD_LOGIC;	--	output  lvds 21
SIGNAL	VMM2_CKTK		: STD_LOGIC;	--	input   lvds 22
SIGNAL	VMM2_DATA0		: STD_LOGIC;	--	output  lvds 23
SIGNAL	VMM2_TKO			: STD_LOGIC;	--	output  lvds 24
SIGNAL	VMM2_ENA			: STD_LOGIC;	--	input   lvds 25
SIGNAL	VMM2_CKBC		: STD_LOGIC;	--	input   lvds 26
SIGNAL	VMM2_CKART		: STD_LOGIC;	-- input   lvds 27
SIGNAL	VMM2_CKDT		: STD_LOGIC;	--	input   lvds 28
SIGNAL	VMM2_WEN			: STD_LOGIC;	--	input   lvds 30
SIGNAL	VMM2_CKTP		: STD_LOGIC;	--	input   lvds 31
SIGNAL	VMM2_DATA1		: STD_LOGIC;	--	output  lvds 33
SIGNAL	VMM2_DI			: STD_LOGIC;	--	input   lvds 35
SIGNAL	VMM2_DO			: STD_LOGIC;	--	output  lvds 36
SIGNAL	VMM2_SETT		: STD_LOGIC;	--	output  lvds 37
SIGNAL   TST_PULSE		: STD_LOGIC;

-----------------------------------------------



BEGIN 


usb_reset			<=  c_flagd;
reset 				<= reg0_p(15);
CHIP_RST				<= reg0_p(14);
LED(7 DOWNTO 0) 	<= X"FF";
SIG_IN				<= reg15_p(0);  -- do not change used to force quartus to keep BLVDS  buffers
ADC_1_CS				<=	ADC_CS;
ADC_1_SCLK			<= ADC_SCK;
ADC_2_CS				<=	ADC_CS;
ADC_2_SCLK			<= ADC_SCK;

ADC_DATA1(31 downto 16) <= x"0000";
ADC_DATA2(31 downto 16) <= x"0000";


b2v_inst_pll : al_pll
	PORT MAP (inclk0 	=> clk_32Mhz,
				 c0 		=> USB_CLK,
				 c1 		=> open
	);

b2v_inst_pll_50 : al_pll_50Mhz
	PORT MAP (	inclk0 => clk_50Mhz,
					c0		 => c50Mhz,
					c1		 => clk_100Mhz,
					c2		 => clk_1Mhz,
					c3		 => sig_tap);			
				
b2v_inst1 : USB_TOP
PORT MAP(USB_IO_CLK 		=> USB_CLK,
			reset 			=> usb_reset,
			c_ctl0_flaga 	=> c_ctl0_flaga,
			c_ctl1_flagb 	=> c_ctl1_flagb,
			c_ctl2_flagac 	=> c_ctl2_flagc,
			c_clkout 		=> c_clkout,
			c_int0 			=> c_int0,
			c_int1 			=> c_int1,
			hs_ffdata 		=> USB_DATA,
			hs_ff_wrreq 	=> USB_wrreq,
			hs_ffclk 		=> c50Mhz,
			data_out 		=> rdout,
			c_ifclk			=> c_ifclk,			
			c_fd 				=> c_fd,
			c_pa2_sloe 		=> c_pa2_sloe,
			c_rdy0_slrd 	=> c_slrd,
			c_rdy1_slwr 	=> c_slwr,		
			c_fifoadr0 		=> c_fifoadr0,
			c_fifoadr1 		=> c_fifoadr1,
			c_pktend 		=> c_pktend,
			c_WU1				=> c_wakeup,
			c_WU2				=> c_wu2,
			hs_ff_wr_full 	=> USB_wfull,
			address 			=> address,
			data 				=> data,
			USB_strb 		=> USB_strb,
			USB_dir 			=> USB_dir,
			sys_clk			=> c50Mhz);	 
			 

			 
b2v_inst2 : IO_registers
PORT MAP( rst 				=> reset,
			 clk 				=> c50Mhz,
			 USB_WR  		=> USB_strb,
			 USB_DIR 		=> USB_dir,
			 USB_address 	=> address,
			 USB_data 		=> data,
			 USB_data_out	=> rdout,	
			 reg0_o 			=> reg0_p,			 
			 reg1_o 			=> reg1_p,
			 reg2_o 			=> reg2_p,
			 reg3_o 			=> reg3_p,
			 reg4_o 			=> reg4_p,
			 reg5_o 			=> reg5_p,
			 reg6_o 			=> reg6_p,
			 reg7_o 			=> reg7_p,
			 reg8_o 			=> reg8_p,
			 reg9_o 			=> reg9_p,
			 reg10_o 		=> reg10_p,
			 reg11_o	 		=> reg11_p,
			 reg12_o 		=> reg12_p,
			 reg13_o 		=> reg13_p,
			 reg14_o 		=> reg14_p,
			 reg15_o 		=> reg15_p,
			 reg0_i 			=> reg0_p,				 
			 reg1_i 			=> reg1_p,
			 reg2_i 			=> vmm_io_out,
			 reg3_i 			=> reg3_p,
			 reg4_i 			=> reg4_p,
			 reg5_i			=> reg5_p,
			 reg6_i 			=> reg6_p,
			 reg7_i 			=> reg7_p,
			 reg8_i 			=> reg8_p,
			 reg9_i 			=> ADC_DATA1,
			 reg10_i 		=> ADC_DATA2,
			 reg11_i 		=> reg11_p,
			 reg12_i 		=> reg12_p,
			 reg13_i 		=> reg13_p,
			 reg14_i 		=> reg14_p,
			 reg15_i 		=> x"00000102");
				
			
--	VMM2_CKDT		<= not reg1_p(0);			
--	VMM2_DI			<= not reg1_p(1);		
--	VMM2_WEN			<= not reg1_p(2);
--	VMM2_ENA			<= not reg1_p(3);
--	VMM2_TKI			<= not reg1_p(4);
--
--	VMM2_CKTK		<= not reg1_p(5);
--	VMM2_CKBC		<= not reg1_p(6);
--	VMM2_CKART		<= not reg1_p(7);
--	VMM2_CKTP		<= not reg1_p(8);

   
vmm_io_out <= 	x"0000" &  b"000" & not VMM2_DO & '0' & not VMM2_ART	& not VMM2_SETB & not VMM2_SETT &   b"000" & not VMM2_TKO &  b"00" & not VMM2_DATA1  & not VMM2_DATA0;



VMM2_READOUT_INST : VMM2_READOUT
	PORT MAP
	(
		clk      		=> c50Mhz,
		rst     			=> reset,
		TST_PULSE		=> TST_PULSE,
		CKBC_PERIOD		=> reg7_p(15 downto 0),
		ACQ_enable 		=> reg3_p(0),
		ADC_INT_EN		=> reg3_p(1),	
		ART_EN			=> reg3_p(2),	
		SW_EN				=> reg2_p(0),
		SW_vmm2_TKI		=> reg1_p(4),
		SW_vmm2_DI		=> reg1_p(1),				
		SW_vmm2_CKTK	=> reg1_p(5),
		SW_vmm2_ENA		=> reg1_p(3),
		SW_vmm2_CKBC	=> reg1_p(6),
		SW_vmm2_CKART	=> reg1_p(7),
		SW_vmm2_CKDT	=> reg1_p(0),			
		SW_VMM2_WEN		=> reg1_p(2),
		SW_VMM2_CKTP	=> reg1_p(8),
		VMM2_TKI			=> VMM2_TKI,
		VMM2_DI			=> VMM2_DI,
		VMM2_CKTK		=> VMM2_CKTK,
		VMM2_ENA			=> VMM2_ENA,
		VMM2_CKBC		=> VMM2_CKBC,
		VMM2_CKART		=> VMM2_CKART,
		VMM2_CKDT		=> VMM2_CKDT,
		VMM2_WEN			=> VMM2_WEN,
		VMM2_CKTP		=> VMM2_CKTP,
	 
      VMM2_ART 		=> not VMM2_ART,
		VMM2_SETT		=> NOT VMM2_SETT,
		VMM2_DATA1		=> NOT VMM2_DATA1,
		VMM2_DATA0		=> NOT VMM2_DATA0,
		VMM2_TKO			=> NOT VMM2_TKO,
		ADDR_OUT			=> LX9_DATA,
		USB_DATA			=> USB_DATA,
		USB_LATCH		=> USB_wrreq
	
	);


	
VMM2_TST_PULSE_inst : VMM2_TST_PULSE
	PORT MAP
	(
		sys_rst     	=> reset,		
		clk_40Mhz    	=> c50Mhz,
		TP_ENABLE		=> reg4_p(15),
		TP_PERIOD		=> reg5_p,
		TP_WIDTH			=> reg6_p(15 downto 0),
		TP_P_TRAIN		=> reg4_p(7 downto 0),
		TST_PULSE		=> TST_PULSE
	);

	
	
inst_ADC_PDO_A :  ADC_AD7276_OS
PORT MAP(clk   		=> USB_CLK,
			rst      	=> reset,      --
			start   		=> reg8_p(15),   --
			OVER_SAMP	=> reg11_p(1 downto 0),--
			ADC_SDO  	=> ADC_1_SDATA, --
			ADC_SCK		=> ADC_SCK,     --
			ADC_CS		=> ADC_CS,      -- 
			DATA_OUT		=> ADC_DATA1(15 downto 0),   --
			RDY			=> open);

			
	
	
			
inst_ADC_TDO_A :  ADC_AD7276_OS
PORT MAP(clk   		=> USB_CLK,
			rst      	=> reset,
			start   		=> reg8_p(15),
			OVER_SAMP	=> reg11_p(1 downto 0),
			ADC_SDO  	=> ADC_2_SDATA,
			ADC_SCK		=> open,
			ADC_CS		=> open,
			DATA_OUT		=> ADC_DATA2(15 downto 0),
			RDY			=> open);



	
	
	
b2v_inst_0 : alt_iobuf_diff		--NC
PORT MAP(i 		=>'0',
			oe 	=> SIG_IN,
			iobar => lvds_n_0,
			io 	=> lvds_p_0,
			o 		=> open);		
	
b2v_inst_1 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_1,
			io 	=> lvds_p_1,
			o 		=> open);	
			
b2v_inst_2 : alt_iobuf_diff		--NC
PORT MAP(i 		=>'0',
			oe 	=> SIG_IN,
			iobar => lvds_n_2,
			io 	=> lvds_p_2,
			o 		=> open);		
		
b2v_inst_3 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_3,
			io 	=> lvds_p_3,
			o 		=> open);		

b2v_inst_4 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_4,
			io 	=> lvds_p_4,
			o 		=> open);	
	
b2v_inst_5 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_5,
			io 	=> lvds_p_5,
			o 		=> open);
			
b2v_inst_6 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_6,
			io 	=> lvds_p_6,
			o 		=> open);		
	
b2v_inst_7 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_7,
			io 	=> lvds_p_7,
			o 		=> open);	
			
b2v_inst_8 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_8,
			io 	=> lvds_p_8,
			o 		=> open);		
		
b2v_inst_9 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_9,
			io 	=> lvds_p_9,
			o 		=> open);		

b2v_inst_10 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_10,
			io 	=> lvds_p_10,
			o 		=> open);		
	
b2v_inst_11 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_11,
			io 	=> lvds_p_11,
			o 		=> open);	
			
b2v_inst_12 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_12,
			io 	=> lvds_p_12,
			o 		=> open);	
		
b2v_inst_13 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_13,
			io 	=> lvds_p_13,
			o 		=> open);		

b2v_inst_14 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_14,
			io 	=> lvds_p_14,
			o 		=> open);		
	
b2v_inst_15 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_15,
			io 	=> lvds_p_15,
			o 		=> open);

b2v_inst_16 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_16,
			io 	=> lvds_p_16,
			o 		=> open);
			
			
b2v_inst_17 : alt_iobuf_diff		--NC
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_17,
			io 	=> lvds_p_17,
			o 		=> open);		
	
b2v_inst_18 : alt_iobuf_diff		--VMM2_SETB
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_18,
			io 	=> lvds_p_18,
			o 		=> VMM2_SETB);	
			
b2v_inst_19 : alt_iobuf_diff		--GND
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_19,
			io 	=> lvds_p_19,
			o 		=> open);		
		
b2v_inst_20 : alt_iobuf_diff		--VMM2_TKI
PORT MAP(i 		=> NOT VMM2_TKI,
			oe 	=> '1',
			iobar => lvds_n_20,
			io 	=> lvds_p_20,
			o 		=> open);		

b2v_inst_21 : alt_iobuf_diff		--VMM2_ART
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_21,
			io 	=> lvds_p_21,
			o 		=> VMM2_ART);		
	
b2v_inst_22 : alt_iobuf_diff		--VMM2_CKTK
PORT MAP(i 		=> NOT VMM2_CKTK,
			oe 	=> '1',
			iobar => lvds_n_22,
			io 	=> lvds_p_22,
			o 		=> open);	
			
b2v_inst_23 : alt_iobuf_diff		--VMM2_DATA0
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_23,
			io 	=> lvds_p_23,
			o 		=> VMM2_DATA0);		
		
b2v_inst_24 : alt_iobuf_diff		--VMM2_TKO
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_24,
			io 	=> lvds_p_24,
			o 		=> VMM2_TKO);		

b2v_inst_25 : alt_iobuf_diff		--VMM2_ENA
PORT MAP(i 		=> NOT VMM2_ENA,
			oe 	=> '1',
			iobar => lvds_n_25,
			io 	=> lvds_p_25,
			o 		=> open);		
	
b2v_inst_26 : alt_iobuf_diff		--VMM2_CKBC
PORT MAP(i 		=> NOT VMM2_CKBC,
			oe 	=> '1',
			iobar => lvds_n_26,
			io 	=> lvds_p_26,
			o 		=> open);
			
b2v_inst_27 : alt_iobuf_diff		--VMM2_CKART
PORT MAP(i 		=> NOT VMM2_CKART,
			oe 	=> '1',
			iobar => lvds_n_27,
			io 	=> lvds_p_27,
			o 		=> open);		
	
b2v_inst_28 : alt_iobuf_diff		--VMM2_CKDT
PORT MAP(i 		=> NOT VMM2_CKDT,
			oe 	=> '1',
			iobar => lvds_n_28,
			io 	=> lvds_p_28,
			o 		=> open);	
			
b2v_inst_29 : alt_iobuf_diff		--GND
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_29,
			io 	=> lvds_p_29,
			o 		=> open);		
		
b2v_inst_30 : alt_iobuf_diff		--VMM2_WEN
PORT MAP(i 		=> NOT VMM2_WEN,
			oe 	=> '1',
			iobar => lvds_n_30,
			io 	=> lvds_p_30,
			o 		=> open);
	
	
b2v_inst_31 : alt_iobuf_diff		--VMM2_CKTP
PORT MAP(i 		=> NOT VMM2_CKTP,
			oe 	=> '1',
			iobar => lvds_n_31,
			io 	=> lvds_p_31,
			o 		=> open);		
	
b2v_inst_32 : alt_iobuf_diff		--GND
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_32,
			io 	=> lvds_p_32,
			o 		=> open);	
			
b2v_inst_33 : alt_iobuf_diff		--VMM2_DATA1
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_33,
			io 	=> lvds_p_33,
			o 		=> VMM2_DATA1);		
		
b2v_inst_34 : alt_iobuf_diff		--GND
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_34,
			io 	=> lvds_p_34,
			o 		=> open);		

b2v_inst_35 : alt_iobuf_diff		--VMM2_DI
PORT MAP(i 		=> NOT VMM2_DI,
			oe 	=> '1',
			iobar => lvds_n_35,
			io 	=> lvds_p_35,
			o 		=> open);		
	
b2v_inst_36 : alt_iobuf_diff		-- VMM2_DO
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_36,
			io 	=> lvds_p_36,
			o 		=> VMM2_DO);
			
b2v_inst_37 : alt_iobuf_diff		-- VMM2_SETT
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_37,
			io 	=> lvds_p_37,
			o 		=> VMM2_SETT);		
	
b2v_inst_38 : alt_iobuf_diff		
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_38,
			io 	=> lvds_p_38,
			o 		=> open);	
			
b2v_inst_39 : alt_iobuf_diff			-- GND
PORT MAP(i 		=> '0',
			oe 	=> SIG_IN,
			iobar => lvds_n_39,
			io 	=> lvds_p_39,
			o 		=> open);		
		
END bdf_type;


--------example output
--------  vmm_A(3)
--------b2v_inst_27 : alt_iobuf_diff
--------PORT MAP(i 		=> vmm_ck,
--------			oe 	=> '1',
--------			iobar => lvds_n_27,
--------			io 	=> lvds_p_27,
--------			o 		=> open);		