--*********************************************************
--* FILE  : USB_registers.VHD
--* Author: Jack Fried
--*
--* Last Modified: 5/19/2005
--*  
--* Description: interface to the cypress USB FIFO's
--*		 		               
--*
--*
--*
--*
--*
--*
--*********************************************************

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;


--  Entity Declaration

ENTITY IO_registers IS

	PORT
	(
		rst         : IN STD_LOGIC;				-- state machine reset
		clk         : IN STD_LOGIC;
		USB_data    : IN STD_LOGIC_VECTOR(15 downto 0);	
		USB_address : IN STD_LOGIC_VECTOR(15 downto 0); 
		USB_WR  	 	: IN STD_LOGIC;	
		USB_DIR 	 	: IN STD_LOGIC;
		USB_data_out: OUT  STD_LOGIC_VECTOR(15 downto 0);
		
		reg0_i		: IN  STD_LOGIC_VECTOR(31 downto 0);		
		reg1_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg2_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg3_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg4_i		: IN  STD_LOGIC_VECTOR(31 downto 0);		
		reg5_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg6_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg7_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg8_i		: IN  STD_LOGIC_VECTOR(31 downto 0);		
		reg9_i		: IN  STD_LOGIC_VECTOR(31 downto 0);
		reg10_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg11_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg12_i		: IN  STD_LOGIC_VECTOR(31 downto 0);		
		reg13_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg14_i		: IN  STD_LOGIC_VECTOR(31 downto 0);	
		reg15_i		: IN  STD_LOGIC_VECTOR(31 downto 0);
		reg0_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);		
		reg1_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg2_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg3_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg4_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);		
		reg5_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg6_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg7_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg8_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);		
		reg9_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg10_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg11_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg12_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);		
		reg13_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg14_o		: OUT  STD_LOGIC_VECTOR(31 downto 0);	
		reg15_o		: OUT  STD_LOGIC_VECTOR(31 downto 0)

	);
	
END IO_registers;


ARCHITECTURE behavior OF IO_registers IS


begin


		 
  USB_data_out		<=  reg0_i(15 downto 0) 	when (USB_address(11 downto 0)	  = x"000")	else
							 reg1_i(15 downto 0) 	when (USB_address(11 downto 0)	  = x"001")	else
							 reg2_i(15 downto 0) 	when (USB_address(11 downto 0)	  = x"002")	else
							 reg3_i(15 downto 0) 	when (USB_address(11 downto 0)	  = x"003")	else
							 reg4_i(15 downto 0) 	when (USB_address(11 downto 0)	  = x"004")	else
							 reg5_i(15 downto 0) 	when (USB_address(11 downto 0)	  = x"005")	else
							 reg6_i(15 downto 0) 	when (USB_address(11 downto 0)	  = x"006")	else
							 reg7_i(15 downto 0) 	when (USB_address(11 downto 0)	  = x"007")	else
							 reg8_i(15 downto 0) 	when (USB_address(11 downto 0)	  = x"008")	else
							 reg9_i(15 downto 0) 	when (USB_address(11 downto 0)	  = x"009")	else
							 reg10_i(15 downto 0)	when (USB_address(11 downto 0)	  = x"00a")	else
							 reg11_i(15 downto 0)	when (USB_address(11 downto 0)	  = x"00b")	else
							 reg12_i(15 downto 0)	when (USB_address(11 downto 0)	  = x"00c")	else
							 reg13_i(15 downto 0)	when (USB_address(11 downto 0)	  = x"00d")	else
							 reg14_i(15 downto 0)	when (USB_address(11 downto 0)	  = x"00e")	else
							 reg15_i(15 downto 0)	when (USB_address(11 downto 0)	  = x"00f")	else		 		 
							 reg0_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"100")	else
							 reg1_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"101")	else
							 reg2_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"102")	else
							 reg3_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"103")	else
							 reg4_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"104")	else
							 reg5_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"105")	else
							 reg6_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"106")	else
							 reg7_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"107")	else
							 reg8_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"108")	else
							 reg9_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"109")	else
							 reg10_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"10a")	else
							 reg11_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"10b")	else
							 reg12_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"10c")	else
							 reg13_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"10d")	else
							 reg14_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"10e")	else
							 reg15_i(31 downto 16) 	when (USB_address(11 downto 0)	  = x"10f")	else
							 X"0000"; 



				
  process(clk,rst) 
  begin
     if (rst = '1') then
		reg0_o		<= X"00000000";		
		reg1_o		<= X"00000000";	
		reg2_o		<= X"00000000";	
		reg3_o		<= X"00000000";	
		reg4_o		<= X"00008000";	
		reg5_o		<= X"0000ffff";	
		reg6_o		<= X"000000ff";	
		reg7_o		<= X"00000004";	
		reg8_o		<= X"00000000";		
		reg9_o		<= X"00000000";	
		reg10_o		<= X"00000000";	
		reg11_o		<= X"00000000";	
		reg12_o		<= X"00000000";		
		reg13_o		<= X"00000000";
		reg14_o		<= X"00000000";	
		reg15_o		<= X"00000000";
	   elsif (clk'event  AND  clk = '1') then
		
		  if (USB_WR = '1' AND USB_DIR = '0') then
     		CASE USB_address(11 downto 0) IS
     			when x"000" => 	reg0_o(15 downto 0)   <= USB_data;
	     		when x"001" => 	reg1_o(15 downto 0)   <= USB_data;	
    	 		when x"002" => 	reg2_o(15 downto 0)   <= USB_data;
     			when x"003" => 	reg3_o(15 downto 0)   <= USB_data;
    	 		when x"004" => 	reg4_o(15 downto 0)   <= USB_data;
     			when x"005" => 	reg5_o(15 downto 0)   <= USB_data;	
     			when x"006" => 	reg6_o(15 downto 0)   <= USB_data;
     			when x"007" => 	reg7_o(15 downto 0)   <= USB_data;
     			when x"008" => 	reg8_o(15 downto 0)   <= USB_data;
     			when x"009" => 	reg9_o(15 downto 0)   <= USB_data;	
     			when x"00A" => 	reg10_o(15 downto 0)   <= USB_data;
     			when x"00B" => 	reg11_o(15 downto 0)   <= USB_data;
     			when x"00C" => 	reg12_o(15 downto 0)   <= USB_data;
     			when x"00D" => 	reg13_o(15 downto 0)   <= USB_data;
     			when x"00E" => 	reg14_o(15 downto 0)   <= USB_data;
     			when x"00F" => 	reg15_o(15 downto 0)   <= USB_data;
				when x"100" => 	reg0_o(31 downto 16)   <= USB_data;
	     		when x"101" => 	reg1_o(31 downto 16)   <= USB_data;	
    	 		when x"102" => 	reg2_o(31 downto 16)   <= USB_data;
     			when x"103" => 	reg3_o(31 downto 16)   <= USB_data;
    	 		when x"104" => 	reg4_o(31 downto 16)   <= USB_data;
     			when x"105" => 	reg5_o(31 downto 16)   <= USB_data;	
     			when x"106" => 	reg6_o(31 downto 16)   <= USB_data;
     			when x"107" => 	reg7_o(31 downto 16)   <= USB_data;
     			when x"108" => 	reg8_o(31 downto 16)   <= USB_data;
     			when x"109" => 	reg9_o(31 downto 16)   <= USB_data;	
     			when x"10A" => 	reg10_o(31 downto 16)   <= USB_data;
     			when x"10B" => 	reg11_o(31 downto 16)   <= USB_data;
     			when x"10C" => 	reg12_o(31 downto 16)   <= USB_data;
     			when x"10D" => 	reg13_o(31 downto 16)   <= USB_data;
     			when x"10E" => 	reg14_o(31 downto 16)   <= USB_data;
     			when x"10F" => 	reg15_o(31 downto 16)   <= USB_data;	
     			WHEN OTHERS =>  
     		end case;  
		end if;
	end if;

end process;
END behavior;
